#include <Wire.h>
#include <SPI.h>
long knock;
long knockpeak;
byte in[20] = {   0,0,0,0,0,       0,0,0,0,0,             0,0,0,0,0,            0,0,0,0,0,                   };
  
byte out[24]= { 1,2,3,4,5,        6,  7,8,9,10,       11,12,13,14,15,        16,17,18,255,255   };
long timelast;
long timelastserial;
boolean knockreading; 
long watchdog;
int WI;
int WG;
int FP;
byte Status;
int test;
int InjectorSize=800;//Sets injector size 800ml/min default
int boosttarget1;
int boosttarget2;
int boosttarget;
int MAF;
int RPM;
int WITarget=25;
void setup()
{
  Serial.begin(115200);
  TCCR0B = TCCR0B & B11111000 | B00000010;//set PWM on D5 for 7812hz
  TCCR1B = TCCR1B & B11111000 | B00000100;// Set D10 to 122hz for water injector
  TCCR2B = TCCR2B & B11111000 | B00000111; // Set D3 to 30hz for WG
  pinMode(5,OUTPUT);
  pinMode(3,OUTPUT);
  pinMode(10,OUTPUT);
  
  SPI.begin();
   pinMode(11, OUTPUT);//to SDO on knock chip
  pinMode(12, INPUT);//to SDI on knock chip
  pinMode(8, OUTPUT);//Windowing trigger to int/hold on knock chip
  pinMode(2, OUTPUT);//CS to cable select pin on knock chip
  digitalWrite(8,HIGH);//place in standby
SPI.setBitOrder(MSBFIRST);
  
  SPI.setClockDivider(SPI_CLOCK_DIV8);
  SPI.setDataMode(SPI_MODE1);
   digitalWrite(8,LOW);
   Serial.println(SPI.transfer(B01110001));//set advanced mode returns 10001110 or 1102 
   digitalWrite(8,HIGH);
   delay(20);
   digitalWrite(8,LOW);
   Serial.println(SPI.transfer(B01000110)); //Oscilator frequency returns 610 - Returns D-7 to D0 of the digital integrator output.
   digitalWrite(8,HIGH);
   delay(20);
   digitalWrite(8,LOW);
   Serial.println(SPI.transfer(B11100000));//Set Channel to 1 Returns 2210 - Set the channel at 1 Returns D9 to D8 followed by six zeros
   digitalWrite(8,HIGH);
   delay(20);
   digitalWrite(8,LOW);
   Serial.println(SPI.transfer(B00010010));//Set the center band-pass freq 17 - 00000001
   digitalWrite(8,HIGH);
   delay(20);
   digitalWrite(8,LOW);
   Serial.println(SPI.transfer(B10111111));//set gain 11100000
   digitalWrite(8,HIGH);
   delay(20);
   digitalWrite(8,LOW);
   Serial.println(SPI.transfer(B11011111));//215
   digitalWrite(8,HIGH);
   delay(20);
  //******************* Clear the SPI data so that first knock indication is real.
   digitalWrite(8,LOW);
   knock = (SPI.transfer(B01000110)<<2); //Oscilator frequency returns 610 - Returns D-7 to D0 of the digital integrator output.
   digitalWrite(8,HIGH);
   delay(1);
   digitalWrite(8,LOW);
  knock= knock + (SPI.transfer(B11100000));//Set Channel to 1 Returns 2210 - Set the channel at 1 Returns D9 to D8 followed by six zeros
   digitalWrite(8,HIGH);
   Serial.println("*************");
 
  
  pinMode(13,OUTPUT);
  
 
  }
  


void loop()
{

 watchdog++; 
  
  
  
  
  
 if ((millis()-timelast)>59 && knockreading==true)
 {
 knockreading=false;
 digitalWrite(2,LOW);
 }
 if (millis()-timelast>60 )
 {
 knockread();//Serial.println((millis())); 
 digitalWrite(2,HIGH);
 knockreading =true;
 timelast=millis();
 }
 
 
 serialin();
 if ((millis()-timelastserial)>50)
 {
 serialout();
 timelastserial=millis();}
 
 control();
 
 
 //Serial.println(Status);
}



void control()
{
 watchdog++;
 int MAP1;
 int MAP2;
 int WIDemand;
 int WGDemand;
 byte A;
 MAP1=analogRead(A7);
 
 out[0]=(MAP1>>8);
 out[1]=(MAP1 - ((MAP1>>8)<<8));
 MAP2=analogRead(A6);
 
 out[2]=(MAP2>>8);
 out[3]=(MAP2 - ((MAP2>>8)<<8));
 FP=analogRead(A3);
 
 out[4]=(FP>>8);
 out[5]=(FP - ((FP>>8)<<8));
 A=analogRead(A2);

 out[6]=(A>>8);
 out[7]=(A - ((A>>8)<<8));
 A=analogRead(A1);

 out[8]=(A>>8);
 out[9]=(A - ((A>>8)<<8));
 A=analogRead(A0);

 out[10]=(A>>8);
 out[11]=(A - ((A>>8)<<8));
 
 out[12]=(knock>>8);
 out[13]=(knock - ((knock>>8)<<8));
 
 if (MAP2>MAP1){MAP1=MAP2;}//Prevents overboost on MAP failure. 
 if (knock>500)
   {
     boosttarget1=0;
     boosttarget2=0;
   }
 
 if (MAF>50)//Check for cruise conditions
 {
 WI=(MAF*WITarget/21); //SET Water injection rate in G/min as a percentage of fuel (compared to 12.5:1)
if (WI>InjectorSize)//check if larger than injector size
{
  WI=InjectorSize;//sets rate in g/min (cc/min)
}
if (WI>0)
{
  WIDemand=(WI*153/InjectorSize)+51;//Set to 20%-80%duty for 0-800cc/min
}
else
{
  WIDemand=0; 
}


//SET Boost Target
//Call Boost PI controller.
boosttarget=(boosttarget1)-(boosttarget1-boosttarget2)*(RPM-4000)/4000;
if (RPM<4000){boosttarget=boosttarget1;}
if (RPM>8000){boosttarget=boosttarget2;}
 int difference;

difference=boosttarget-MAP1+23;
if (difference>46){ difference=46;}
if (difference<0){ difference=0;}
if (boosttarget>0){WGDemand=difference*255/46;}
else{WGDemand=0;}//Set to zero if target is zero
 }
else{
//if (MAF<10&&RPM<1500)
//{WGDemand=255; }
//else{WGDemand=0; }//Cruise conditions->No WI no WG
WGDemand=0;
WIDemand=0; WI=0;
}

if (WGDemand>255){WGDemand=255;}
if (WIDemand>255){WIDemand=255;}

 
 
 
 
 
 
 if (watchdog<200)// All good
 {
 
 
 }
 else
 {
 boosttarget1=0;
 boosttarget2=0;
 WIDemand=0;
 WGDemand=0;
 FP=255;
   
 }
 
 analogWrite(10, WIDemand);
 analogWrite(3, WGDemand);
 //analogWrite(5, FPDemand);
 out[14]=WI/4;
out[15]=WGDemand;

}





void knockread()
{
  //*********************READ SPI DATA******************************************
  digitalWrite(8,LOW);
   knock = (SPI.transfer(B01000110)<<2); //Oscilator frequency returns 610 - Returns D-7 to D0 of the digital integrator output.
   digitalWrite(8,HIGH);
   delay(1);
   digitalWrite(8,LOW);
  knock= knock + (SPI.transfer(B11100000));//Set Channel to 1 Returns 2210 - Set the channel at 1 Returns D9 to D8 followed by six zeros
   digitalWrite(8,HIGH);
   if (knock>knockpeak)
   {
     knockpeak=knock;
   }
   //Serial.println(analogRead(A6));
}

int serialout()//Writes two start bytes and then 20byte message
{
  out[16]=(boosttarget1>>8);
 out[17]=(boosttarget1 - ((boosttarget1>>8)<<8));
 out[18]=(boosttarget2>>8);
 out[19]=(boosttarget2 - ((boosttarget2>>8)<<8));
 //out[22]=23;
// out[22]=watchdog/10;
 out[22]=WITarget;//******************Easy variable for testing.
  Serial.write(47);
  Serial.write(47);
  for (int x=0; x<23;x++)
  {Serial.write(out[x]);
  }
  knockpeak=0;
}

int serialin()//Checks for a full message then checks for two start bytes.
{
   if (Serial.available()>23)//checks for a complete command
 {
 if (Serial.read()==47)
 {
   if (Serial.read()==47)
   {
     for (int x=0; x<20;x++)
     {
     in[x]=Serial.read();
     }
    if (in[0]!=255)
   {watchdog=0;} 
    //MAF=int(long(in[3])*256/100);
     MAF=(long(in[3])*256+long(in[4]))/100;
     RPM=(long(in[5])*256+long(in[6]))/4;
     if (in[0]==10)//demand to change BT1
     {
       boosttarget1=in[1]*4;
     }
     if (in[0]==11)//demand to change BT1
     {
       boosttarget2=in[1]*4;
     }
     if (in[0]==12)//demand to change BT1
     {
       WITarget=in[1];
     }
     if (in[0]==2)//Test WI
     {
       analogWrite(3, 0);//Zero Wastegate
       analogWrite(10,in[1]);
       delay(15000); //15set delay
       
     }
     if (in[0]==3)//Test WI
     {
       
       analogWrite(3,in[1]); //TEST WASTEGATE CLosed
       delay(30000); //15set delay
       
     }
     
     
   }
 }
   
 }
}

