#include <Wire.h>
#include <FlexCAN.h>
#include <TimerOne.h>
byte in[22] = {0,0,0,0,0,   0,0,0,0,0,   0,0,0,0,0,   0,0,0,0,0 };
byte out[20]= { };
FlexCAN CANbus(500000);
static CAN_message_t msg,rxmsg;
static CAN_filter_t rxEcu, rxAdapter;
int MAFCount;//counters to automaticaly poll ECU parameters.
int MAFCount2;
int IATCount=50;
int IATCount2=50;
int RPMCount=75;
int RPMCount2=75;
int ECTCount=100;
int ECTCount2=100;
unsigned long timelastserial;
int MAF;
int RPM;
int boosttarget;
int boosttarget1;
int boosttarget2;
int WI;
int WITarget=25;
int WIDemand;
int WGDemand;
int FPDemand;
int IAT;
int ECT;
byte A1H;
byte A1L;
byte A2H;
byte A2L;
byte A3H;
byte A3L;
byte A4H;
byte A4L;
byte A5H;
byte A5L;
byte A6H;
byte A6L;
byte KNH;
byte KNL;
int Controldelay;
int knock;
int Status;
long lastserial;
void setup()
{
  //delay(7000);
  rxEcu.id = 0x7D8;
  rxAdapter.id = 0x7E8;
  Wire.begin();        // join i2c bus (address optional for master)
  Serial1.begin(115200);  // start serial for output
 
 Timer1.initialize(33);
  Timer1.attachInterrupt(MasterCycler); // Controls PWM and Knock sensor without delays
  CANbus.begin();
  CANbus.setFilter(rxEcu,0 );
  CANbus.setFilter(rxAdapter,1);
  CANbus.setFilter(rxAdapter,2);
  CANbus.setFilter(rxAdapter,3);
  CANbus.setFilter(rxAdapter,4);
  CANbus.setFilter(rxAdapter,5);
  CANbus.setFilter(rxAdapter,6);
  CANbus.setFilter(rxAdapter,7);
  pinMode(13,OUTPUT);
  
 
}

void loop()
{//Wire.begin();  
 
 

  
  CANRead();
  
  
  

  CANPolling();
   serialin();//Polling
   if ((millis()-timelastserial)>50)
 {
 serialout();
 timelastserial=millis();}
  
  
  
}
////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
void CANPolling()//Polls Can Buss for info at set intervals
{
    if (MAFCount2>2)//Triggers polling if >100MSEC
  {
    
    msg.len = 3; msg.id = 0x7D8;msg.buf[0]=2;//number of bytes 
    msg.buf[1]=1; msg.buf[2]=16;//PID 16 for MAF
    msg.buf[3]=0; msg.buf[4]=0; msg.buf[5]=0; msg.buf[6]=0; msg.buf[7]=8;
    CANbus.write(msg); MAFCount2=0;//Resets the trigger counter
    //Serial1.println("MAF READ");
  }
  
  if (RPMCount2>5)//Triggers polling every 200msec
  {
    
    msg.len = 3; msg.id = 0x7D8; msg.buf[0]=2;//number of bytes
    msg.buf[1]=1; msg.buf[2]=12;//PID 13 for speed
    msg.buf[3]=0; msg.buf[4]=0; msg.buf[5]=0; msg.buf[6]=0; msg.buf[7]=8;
    CANbus.write(msg); RPMCount2=0;
    //Serial1.println("RPM READ");
    
  }
  if (MAFCount>10){MAF=0; boosttarget1=0;boosttarget2=0;}//If comunication is lost stop all boost.
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CANRead()//Reads and responds to can requests
{
  if ( CANbus.read(rxmsg) ) {
     /* 
      Serial1.print("LEN"); Serial1.print(rxmsg.len); Serial1.print("ID"); Serial1.print(rxmsg.id); Serial1.print("=");
      Serial1.print(rxmsg.buf[0]); Serial1.print(" , "); Serial1.print(rxmsg.buf[1]); Serial1.print(" , "); Serial1.print(rxmsg.buf[2]);
      Serial1.print(" , "); Serial1.print(rxmsg.buf[3]); Serial1.print(" , "); Serial1.print(rxmsg.buf[4]); Serial1.print(" , ");
      Serial1.print(rxmsg.buf[5]); Serial1.print(" , "); Serial1.print(rxmsg.buf[6]); Serial1.print(" , "); Serial1.print(rxmsg.buf[7]);
      Serial1.println("");
      */
          
  
     
        if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==10)    //PID 0A FUEL PRESSURE
        
        {
          msg.len = 8; msg.id = 0x7E8; msg.buf[0]=4;
          msg.buf[1]=65; msg.buf[2]=34;//PID 13 for speed
          //msg.buf[3]=3; msg.buf[4]=254;
          
          msg.buf[3]=A3H; msg.buf[4]=A3L;
          msg.buf[5]=0;
          msg.buf[6]=0;
          msg.buf[7]=0;    
          CANbus.write(msg);
              
        }
        
           if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==92)    //PID 5C
        
        {
          msg.len = 8; msg.id = 0x7E8; msg.buf[0]=3;//number of bytes
          msg.buf[1]=65; msg.buf[2]=34;//PID 13 for speed
          msg.buf[3]=random(0,125); msg.buf[4]=0;//224;//valueB
          msg.buf[5]=0;
          msg.buf[6]=0;
          msg.buf[7]=0;
          CANbus.write(msg);
        
        }
        
        
        
        
          if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==197)   //PID C5 
        
        {
          msg.len = 8; msg.id = 0x7E8; msg.buf[0]=4;//number of bytes
          msg.buf[1]=65; msg.buf[2]=197;//PID 13 for speed
          msg.buf[3]=A1H; msg.buf[4]=A1L;
          //msg.buf[3]=2; msg.buf[4]=9;
          msg.buf[5]=0; msg.buf[6]=0; msg.buf[7]=0;
          CANbus.write(msg);

        }
         if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==198)    //PID C6
        
        {
          msg.len = 8; msg.id = 0x7E8; msg.buf[0]=4;//number of bytes
          msg.buf[1]=65; msg.buf[2]=198;//PID 13 for speed
          msg.buf[3]=A2H; msg.buf[4]=A2L;
          msg.buf[5]=0; msg.buf[6]=0; msg.buf[7]=0;
          CANbus.write(msg);
               
        }
        
        
        if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==199)    //PID C7
        
        {
          msg.len = 8; msg.id = 0x7E8; msg.buf[0]=4;//number of bytes
          msg.buf[1]=65; msg.buf[2]=199;//PID 13 for speed
          msg.buf[3]=((in[14]*4)>>8); msg.buf[4]=((in[14]*4) - (((in[14]*4)>>8)<<8));
          msg.buf[5]=0; msg.buf[6]=0; msg.buf[7]=0;
          CANbus.write(msg);
               
        }
        
         if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==200)    //PID C8
        
        {
          msg.len = 8; msg.id = 0x7E8; msg.buf[0]=4;//number of bytes
          msg.buf[1]=65; msg.buf[2]=200;//PID 13 for speed
          msg.buf[3]=in[16]; msg.buf[4]=in[17];
          msg.buf[5]=0; msg.buf[6]=0; msg.buf[7]=0;
          CANbus.write(msg);    
          
        }
        
          if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==201)    //PID C9
        
        {
          msg.len = 8; msg.id = 0x7E8; msg.buf[0]=4;//number of bytes
          msg.buf[1]=65; msg.buf[2]=201;//PID 13 for speed
          msg.buf[3]=in[18]; msg.buf[4]=in[19];
          msg.buf[5]=0; msg.buf[6]=0; msg.buf[7]=0;
          CANbus.write(msg);
             
        }
          if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==202)    //PID CA
        
        {
          msg.len = 8;
    
     msg.id = 0x7E8;
    msg.buf[0]=4;//number of bytes
    msg.buf[1]=65;//
    msg.buf[2]=202;//PID 13 for speed
   msg.buf[3]=(in[20]); msg.buf[4]=(in[21]);
   
    msg.buf[5]=185;
    msg.buf[6]=147;
    //msg.buf[7]=8;
   
    
    
      CANbus.write(msg);
      //Serial1.println("WI Setpoint");
          
        }
        
          if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==203)    //PID CB
        
        {
          msg.len = 8;
    
     msg.id = 0x7E8;
    msg.buf[0]=4;//number of bytes
    msg.buf[1]=65;//
    msg.buf[2]=203;//PID 13 for speed
    msg.buf[3]=in[22];
    msg.buf[4]=0;//224;//valueB
    msg.buf[5]=185;
    msg.buf[6]=147;
    //msg.buf[7]=8;
   
  
    
      CANbus.write(msg);
      //Serial1.println("Oil Pressure");
          
        }
           if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==204)    //PID CC
        
        {
          msg.len = 8;
    
     msg.id = 0x7E8;
    msg.buf[0]=4;//number of bytes
    msg.buf[1]=65;//
    msg.buf[2]=204;//PID 13 for speed
    msg.buf[3]=in[15];
    msg.buf[4]=0;//224;//valueB
    msg.buf[5]=185;
    msg.buf[6]=147;
    //msg.buf[7]=8;
  
    
    
      CANbus.write(msg);
      //Serial1.println("Fuel Pump Demand");
          
        }
            if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==205)    //PID CC
        
        {
          msg.len = 8;
    
     msg.id = 0x7E8;
    msg.buf[0]=4;//number of bytes
    msg.buf[1]=65;//
    msg.buf[2]=205;//PID 13 for speed
    //Serial1.println(knock);
    msg.buf[3]=in[12];
    msg.buf[4]=in[13];
    msg.buf[5]=185;
    msg.buf[6]=147;
    //msg.buf[7]=8;
    

    
    
      CANbus.write(msg);
      //Serial1.println("Fuel Pump Demand");
          
        }
                    if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==206)    //PID CC
        
        {
          msg.len = 8;
    
     msg.id = 0x7E8;
    msg.buf[0]=3;//number of bytes
    msg.buf[1]=65;//
    msg.buf[2]=206;//PID 13 for speed
    msg.buf[3]=in[23];
    msg.buf[4]=0;//224;//valueB
    msg.buf[5]=185;
    msg.buf[6]=147;
    //msg.buf[7]=8;
  
    
    
      CANbus.write(msg);
      //Serial1.println("Fuel Pump Demand");
          
        }

                                            if (rxmsg.buf[0]==2 && rxmsg.buf[1]==1 && rxmsg.buf[2]==210)    //PID CC
        
        {
          msg.len = 8;
    
     msg.id = 0x7E8;
    msg.buf[0]=3;//number of bytes
    msg.buf[1]=65;//
    msg.buf[2]=210;//PID 13 for speed
    msg.buf[3]=0;//Lockout;
    msg.buf[4]=0;//224;//valueB
    msg.buf[5]=185;
    msg.buf[6]=147;
    //msg.buf[7]=8;
  
    
    
      CANbus.write(msg);
      //Serial1.println("Fuel Pump Demand");
          
        }
      ///240-255 commands
          if (rxmsg.buf[0]==3 && rxmsg.buf[1]==2 && rxmsg.buf[2]==240)    //PID F0 RAW 02F0 then boost setpoint 02F010 for 16/1023*2bar
        
        {
      out[0]=10; //Set boost target1
      out[1]=(rxmsg.buf[3]);   
                
        }
            if (rxmsg.buf[0]==3 && rxmsg.buf[1]==2 && rxmsg.buf[2]==241)    //PID F1
        
        {
      out[0]=11; //Set boost target1
      out[1]=(rxmsg.buf[3]);
          
        }
        
             if (rxmsg.buf[0]==3 && rxmsg.buf[1]==2 && rxmsg.buf[2]==242)    //PID F2
        
        {
     out[0]=12; //Set boost target1
      out[1]=(rxmsg.buf[3]);     
     
          
        }
            if (rxmsg.buf[0]==3 && rxmsg.buf[1]==2 && rxmsg.buf[2]==243)    //PID F3
        
        {
        out[0]=2; //Test WI solenoid for 15 sec
      out[1]=(rxmsg.buf[3]);   
        
        }
        
      
     //******************************************Store recieved data
     
     
          if (rxmsg.id == 0x7E8 && rxmsg.buf[1]==65 && rxmsg.buf[2]==16)    //PID F1
        
        {
         //MAF=((rxmsg.buf[3]*256)+rxmsg.buf[4])/100;
         out[3]=rxmsg.buf[3];
         out[4]=rxmsg.buf[4];
         MAFCount=0;
         MAFCount2=0;
          
        }
          if (rxmsg.id == 0x7E8 && rxmsg.buf[1]==65 && rxmsg.buf[2]==12)    //PID F1
        
        {
         //RPM=((rxmsg.buf[3]*256)+rxmsg.buf[4])/4; 
         out[5]=rxmsg.buf[3];
         out[6]=rxmsg.buf[4];  
         RPMCount=0;
         RPMCount2=0;
          
        }
          if (rxmsg.id == 0x7E8 && rxmsg.buf[1]==65 && rxmsg.buf[2]==15)    //PID F1
        
        {
         IAT=(rxmsg.buf[3]-40)*5/9 +32;
         // Serial1.println(rxmsg.buf[3]);   
         IATCount=0;
         IATCount2=0;
          
        }
          if (rxmsg.id == 0x7E8 && rxmsg.buf[1]==65 && rxmsg.buf[2]==5)    //PID F1
        
        {
        ECT=(rxmsg.buf[3]-40)*5/9 +32;
         ECTCount=0;
         ECTCount2=0;
          
        }
      
  


}
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////
//Master Cycler
void MasterCycler()
{

Controldelay++;//Delay for calling control functions
if (Controldelay>3030)//100ms counter
{
  Controldelay=0;
  MAFCount++;//counters to automaticaly poll ECU parameters.
  MAFCount2++;
  IATCount++;
  IATCount2++;
  RPMCount++;
  RPMCount2++;
  ECTCount++;
}
 
}

///////////////////////////////////////////////
int serialout()//Writes two start bytes and then 20byte message
{
  Serial1.write(47);
  Serial1.write(47);
  for (int x=0; x<20;x++)
  {Serial1.write(out[x]);
  }
  out[0]=1;//Status normal
  out[1]=0;//No change
}

int serialin()//Checks for a full message then checks for two start bytes.
{
   if (Serial1.available()>24)//checks for a complete command
 {
 if (Serial1.read()==47)//check for begining of line.
 {
   if (Serial1.read()==47)//do it twice for safety. if not, kick out until buffer full again.
   {
     for (int x=0; x<23;x++)
     {
       in[x]=Serial1.read();
     }
      A1H=in[0];
  A1L=in[1];  
  A2H=in[2];
  A2L=in[3]; 
  A3H=in[4];
  A3L=in[5]; 
  A4H=in[6];
  A4L=in[7]; 
  A5H=in[8];
  A5L=in[9]; 
  A6H=in[10];
  A6L=in[11]; 
  KNH=in[12];
  KNL=in[13];
  int knocktemp;
  knocktemp=KNH*256+KNL;
  if (knocktemp>knock)
  {
    knock=knocktemp;
  }
   }
 }
   
 }
}

